TITLE read ROM BIOS at vector 1Eh program
;........................................................................
msg	MACRO	msgout
	mov AH, 09h			; function 09h
	lea DX, msgout		; DX holds message
	int 21h 			; display string interupt
ENDM
;........................................................................
.MODEL small		      ; directive placing all memory in one segment
;........................................................................
;
;.............................; stack segment............................
StackSeg segment stack	      ; stack segment begins
	DB 1024 DUP(?)        ; amass 1032 bytes of memory
StackSeg ends		      ; stack segment ends
;........................................................................
;
;.............................; data segment.............................
DataSeg segment

	Message	DB 0Ah,0Dh,"     This program looks at the floppy disk parameters",0Ah,0Dh,"     block stored in ROM-BIOS at vector 1Eh",'$'
	CRLF		DB ".",0Ah,0Dh,'$'	; period, carriage return, & line feed
	CW		DB 0Ah,0Dh,"     Freehafer's View Vector 1Eh Program",0Ah,0Dh,"     (C)2002 Inniea Publishing Company R",153,142,"K NOG!",0Ah,0Dh,0Ah,0Dh,'$'
	SRmsg		DB 0Ah,0Dh,"     Bits 4-7 : Step rate; Bits 0-3 : Head unload time = ",'$'
	srSRmsg	DB "                                      Step rate        = ",'$'
	utSRmsg	DB "                                      Head unload time = ",'$'
	LTmsg		DB "     Bits 0-6 : Head load time; Bit 7 : DMA flag       = ",'$'
	ltLTmsg	DB "                                      Head load time   = ",'$'
	dmLTmsg	DB "                                      DMA flag         = ",'$'
	MOmsg		DB "     Motor off time                                    = ",'$'
	SSmsg		DB "     Sector size in bytes (MS-DOS standard = 2)        = ",'$'
	LSmsg		DB "     Sectors per track                                 = ",'$'
	FGmsg		DB "     Size of gap between sectors on read/write         = ",'$'
	LDmsg		DB "     Length of data transfer (standard = 255)          = ",'$'
	SGmsg		DB "     Size of gap between sectors on format             = ",'$'
	BFmsg		DB "     Byte for filling on format                        = ",'$'
	HSmsg		DB "     Head-settle time in milliseconds                  = ",'$'
	MSmsg		DB "     Motor start-up time                               = ",'$'
	NUM		DW ?

;........................................................................
DataSeg ends		      ; data segment ends	
;........................................................................
;
;........................................................................
EDataSeg segment		      	
	esbuffer	DB 1024 DUP(?)
EDataSeg ends
;........................................................................
;
;.............................; code segment begins......................
CodeSeg segment  
;........................................................................
;
;.............................; tell assembler which segment is in what register
assume cs:CodeSeg, ds:DataSeg, ss:StackSeg, es:EDataSeg
;........................................................................ 
;              
start:     		            ; begin algorithm
;........................................................................
;					; move data segment into DS
;........................................................................
	mov AX,DataSeg	      ; base address
	mov DS,AX		      ; of data segment
;........................................................................
;					; clear screen
;........................................................................
	mov AH, 2			; function number
	mov BH, 0			; video page
	mov DX, 0			; top left corner
	int 10h			; interrupt call
;........................................................................
;					; yellow background with black font
;........................................................................
	mov AH,9			; function number
	mov CX, 2000		; number of characters of output
	mov BL, 0E0h		; color code
	mov AL, " "			; blank characters
	int 10h			; call interrupt
;........................................................................
;					; display what program does
;........................................................................
	msg Message			; what program does
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; access BIOS Data Area right before display
;........................................................................
	mov AX, 0h			; segment address of IVT
	mov ES, AX			; ES points to the IVT segment
	mov BX, ES:78h		; pointer for disk parameter table -- vector 1Eh (78h=4*1Eh)
	mov AX, ES:7Ah		; take segment address for vector 1Eh
	mov ES, AX			; ES:BX now points to Floppy Disk Paramet Table
;					; this also works***************
	;mov AH, 35h		; get interrupt vector function
	;mov AL, 1Eh		; interrupt handler
	;int 21h			; call interrupt where 
;					; output ES:BX = segment offset of interrupt handler
;........................................................................
;					; display word for step rate
;........................................................................
	msg SRmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 00h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for step rate part of step rate
;........................................................................
	msg srSRmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 00h] ; Place number to be printed into AX.
	mov CX, 4
srloop:
	shr AX, 1
	loop srloop			; bits 4-7 of AX
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for unload time part of step rate
;........................................................................
	msg utSRmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 00h] ; Place number to be printed into AX.
	mov CX, 12
lutloop:
	shl AX, 1
	loop lutloop
	mov CX, 12
rutloop:
	shr AX, 1
	loop rutloop		; bits 0-3 of AX
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for load time
;........................................................................
	msg LTmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 01h] ; Place number to be printed into AX.
	MOV NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for load time part of load time
;........................................................................
	msg ltLTmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 01h] ; Place number to be printed into AX.
	mov CX, 10
lltloop:
	shl AX, 1
	loop lltloop
	mov CX, 10
rltloop:
	shr AX, 1
	loop rltloop		; bits 0-6 of AX
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for DMA flag part of load time
;........................................................................
	msg dmLTmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 01h] ; Place number to be printed into AX.
	mov CX, 7
dmloop:
	shr AX, 1
	loop dmloop			; bits 7 of AX
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for motor off time
;........................................................................
	msg MOmsg			; value message
	mov AX, 0			; empty AX
	mov AL,BYTE PTR ES:[BX + 02h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for sector size
;........................................................................
	msg SSmsg			; value message
	mov AX, 0			; empty AX
	mov AL, BYTE PTR ES:[BX + 03h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for last sector
;........................................................................
	msg LSmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 04h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for size of gap between sectors on format
;........................................................................
	msg FGmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 05h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for length of data transfer 
;........................................................................
	msg LDmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 06h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for size of gap between sectors on format
;........................................................................
	msg SGmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 07h] ; Place number to be printed into AX.
	mov NUM, AX
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for byte for filling format
;........................................................................
	msg BFmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 08h] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for head settle time
;........................................................................
	msg HSmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 09h] ; Place number to be printed into AX.
	mov NUM, AX
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
;					; display word for byte for motor start-up time
;........................................................................
	msg MSmsg			; value message
	mov AX, 0
	mov AL, BYTE PTR ES:[BX + 0Ah] ; Place number to be printed into AX.
	mov NUM, AX			; 
	CALL DisplayNum		; display number
	msg CRLF			; period, carriage return, and line feed
;........................................................................
	msg CW			; copywrite
;........................................................................
;					; end program
;........................................................................
	mov AX,4C00h		; 
	int 21h			; termination interupt
;........................................................................
;					; Display Number Procedure
;........................................................................
	DisplayNum proc
	push AX
	push BX
	push CX
	push DX
      mov AX, NUM			; Number To Be Displayed
	mov BX, 10
	mov CX, 0
DNexDiv:
	mov DX, 0
	div BX
	push DX
	inc CX
	cmp AX,0
	jne DNexDiv
	mov AX, 200h
DOutSym: pop DX
	add DL, '0'
	int 21h
	loop DOutSym
	pop DX
	pop CX
	pop BX
	pop AX
	ret
	DisplayNum endp
;........................................................................
CodeSeg    ends       	      ; end algorithm
;........................................................................
end  start 			      ; end program